function CreateViewModel(modelName)
{
    local viewModel = SpawnEntityFromTable("tf_wearable_vm", {});
    viewModel.SetAbsOrigin(self.GetOrigin());
    viewModel.SetAbsAngles(self.GetAbsAngles());
	viewModel.SetModel(modelName);
    SetPropBool(viewModel, "m_bForcePurgeFixedupStrings", true);
    self.EquipWearableViewModel(viewModel);
	return viewModel;
}

function CreateWorldModel(modelName)
{
    local worldModel = SpawnEntityFromTable("tf_wearable", { });
    worldModel.SetAbsOrigin(self.GetOrigin());
    worldModel.SetAbsAngles(self.GetAbsAngles());
	worldModel.SetModel(modelName);
    SetPropBool(worldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(worldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(worldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
	SetPropEntity(worldModel, "m_hOwnerEntity", self);
    EntFireByHandle(worldModel, "SetParent", "!activator", 0, self, self);
	return worldModel;
}

function ChangeWorldModel(item, newModelName)
{
    local modelIndex = GetModelIndex(newModelName);
    for (local i = 0; i < 4; i++)
        SetPropIntArray(item, "m_nModelIndexOverrides", modelIndex, i);
}

function ChangeWorldModelIndex(item, newModelNameIndex)
{
    for (local i = 0; i < 4; i++)
        SetPropIntArray(item, "m_nModelIndexOverrides", newModelNameIndex, i);
}

function PlayViewModelAnim(animation)
{
    local viewmodel = GetPropEntity(self, "m_hViewModel");
    if (viewmodel)
        viewmodel.SetSequence(viewmodel.LookupSequence(animation))
}