IncludeScript("vip/gamemode/util.nut");
IncludeScript("vip/gamemode/gamerules.nut");
IncludeScript("vip/gamemode/capture_point_filtering.nut");
IncludeScript("vip/gamemode/attack_defend.nut");
IncludeScript("vip/gamemode/overtime.nut");
IncludeScript("vip/gamemode/entityio.nut");
IncludeScript("vip/gamemode/vip_team_outline.nut");

foreach(name, script in VIP_SCRIPTS)
    IncludeCharacter(name, script);

::vipPlayers <- [null, null, null, null, null];

::GetVIP <- function(team)
{
    local vip = vipPlayers[team];
    return IsValidPlayer(vip) && GetCustomCharacter(vip) ? vipPlayers[team] : null;
}

::GetTeamName <- function(player)
{
    local team = player.GetTeam();
    return team == 2 ? "RED" : team == 3 ? "BLU" : "UNKNOWN";
}

::IsTeammateOrSpy <- function(playerA, playerB)
{
    return playerA.GetTeam() == playerB.GetTeam() || GetPropInt(playerB, "m_Shared.m_nDisguiseTeam") == playerA.GetTeam();
}

::IsVIP <- function(player)
{
    return player && GetVIP(player.GetTeam()) == player;
}

function ConvertToVIP(player)
{
    local team = player.GetTeam();
    vipPlayers[team] = player;
    ConvertToCustomCharacter(player, API_GetString("vip_character"));
}

function ShowVIPAnnotation(player)
{
    local vip = GetVIP(player.GetTeam());
    if (!vip)
        return;
    local myPos = vip.GetOrigin() + Vector(0, 0, 100);
    SendGlobalGameEvent("show_annotation",
    {
        worldPosX = myPos.x,
        worldPosY = myPos.y,
        worldPosZ = myPos.z,
        id = 121,
        text = "VIP",
        lifetime = 6,
        follow_entindex = vip.entindex(),
        visibilityBitfield = 1 << player.entindex()
    });
}
OnGameEvent("player_spawn_post", 0, ShowVIPAnnotation);
OnGameEvent("player_teleported", 0, ShowVIPAnnotation);