canBePicked <- true;

//Failsafe
AddTimer(1, function()
{
    local myVIP = GetVIP(self.GetTeam());
    if (!canBePicked && (!myVIP || myVIP.GetTeam() != self.GetTeam()))
        Enable();
})

OnGameEvent("vip_death", 0, function(player, params)
{
    if (player.GetTeam() == self.GetTeam())
        Enable();
});

function CaneThink()
{
    if (canBePicked)
        PickUpTick();
    return 0.1;
}

function PickUpTick()
{
    if (GetVIP(self.GetTeam()))
    {
        Disable();
        canBePicked = false;
        return;
    }
    local frame = GetPropInt(self, "m_ubInterpolationFrame");
    self.SetAbsAngles(self.GetAbsAngles() + QAngle(0, 10, 0));
    SetPropInt(self, "m_ubInterpolationFrame", frame);

    local myPos = self.GetOrigin();
    foreach(player in GetAlivePlayers())
    {
        if (player.GetTeam() != self.GetTeam())
            continue;
        if ((myPos - player.GetCenter()).Length() < 75)
        {
            Disable();
            main_script.ConvertToVIP(player);
            if (GetPersistentVar("unstuck", true) && API_GetBool("snap_to_pickup"))
                player.SetAbsOrigin(self.GetOrigin());
            return;
        }
    }
}

function OnPostSpawn()
{
    RunWithDelay(0.5, function()
    {
        local newVIP = RandomElement(GetAlivePlayers(self.GetTeam()));
        if (!newVIP || isDebug)
        {
            Enable();
            return;
        }

        Disable();
        main_script.ConvertToVIP(newVIP);
    });
}

function Enable()
{
    canBePicked = true;
    self.SetSkin(self.GetTeam() - 2);
    self.EnableDraw();
    Nag();

    EntFireByHandle(SpawnEntityFromTable("info_particle_system",
    {
        origin = self.GetOrigin() - Vector(0, 0, 20),
        effect_name = "spellbook_major_burning",
        start_active = 1
    }), "SetParent", "!activator", -1, self, self);
}

function Disable()
{
    canBePicked = false;
    self.DisableDraw();
    local entsToKill = [];
    for (local child = self.FirstMoveChild(); child != null; child = child.NextMovePeer())
        entsToKill.push(child);
    foreach (ent in entsToKill)
        ent.Kill();
}

function Nag()
{
    RunWithDelay(10, function()
    {
        if (!canBePicked)
            return;
        local teammateBits = 1;
        foreach(player in GetAllPlayers())
        {
            if (player.GetTeam() == self.GetTeam())
                teammateBits = teammateBits | (1 << player.entindex());
        }
        local myPos = self.GetOrigin() + Vector(0, 0, 30);
        SendGlobalGameEvent("show_annotation",
        {
            worldPosX = myPos.x,
            worldPosY = myPos.y,
            worldPosZ = myPos.z,
            id = 124,
            text = "Touch the Cane to become the VIP!",
            lifetime = 6,
            visibilityBitfield = teammateBits,
            play_sound = "ui/hint.wav"
        });
        Nag();
    });
}