obj_tele <- player_collection(null);
ent_glow <- player_collection(null);

function RespawnVIPGlow(player)
{
    local pindex = player.entindex();
    local obj_tele = obj_tele[pindex];
    local ent_glow = ent_glow[pindex];

    local vip = GetVIP(player.GetTeam());
    if (!vip || player == vip)
    {
        KillIfValid(obj_tele);
        KillIfValid(ent_glow);
        return;
    }

    if (!IsValid(obj_tele) || !IsValid(ent_glow))
    {
        KillIfValid(obj_tele);
        KillIfValid(ent_glow);

        obj_tele = Entities.CreateByClassname("obj_teleporter");
        obj_tele.SetAbsOrigin(vip.GetOrigin());
        obj_tele.DispatchSpawn();
        obj_tele.SetModel(GetCustomCharacter(vip).model);
        obj_tele.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION);
        obj_tele.SetSolid(Constants.ESolidType.SOLID_NONE);
        SetPropBool(obj_tele, "m_bPlacing", true);
        SetPropInt(obj_tele, "m_fObjectFlags", 2);
        SetPropEntity(obj_tele, "m_hBuilder", player);

        SetPropInt(obj_tele, "m_fEffects", 145);
        SetPropInt(obj_tele, "m_nNextThinkTick", 0x7FFFFFFF);
        SetPropBool(obj_tele, "m_bForcePurgeFixedupStrings", true);
        EntFireByHandle(obj_tele, "SetParent", "!activator", 0, vip, vip);

        local name = obj_tele.GetScriptId();
        SetPropString(obj_tele, "m_iName", name);

        ent_glow = SpawnEntityFromTable("tf_glow", {
            target = name
            StartDisabled = 0
            GlowColor = player.GetTeam() == TF_TEAM_RED ? "190 48 48 255" : "179 225 255 255"
        });
        ent_glow.SetAbsOrigin(vip.GetOrigin());
        SetPropBool(ent_glow, "m_bForcePurgeFixedupStrings", true);
        EntFireByHandle(ent_glow, "SetParent", "!activator", 0, vip, vip);

        this.obj_tele[pindex] = obj_tele;
        this.ent_glow[pindex] = ent_glow;
    }
}

function DeleteVIPGlow(player)
{
    local pindex = player.entindex();
    KillIfValid(obj_tele[pindex]);
    KillIfValid(ent_glow[pindex]);
}

OnGameEvent("player_spawn", RespawnVIPGlow);

OnGameEvent("vip_spawn", function(player)
{
    foreach (teammate in GetAlivePlayers(player.GetTeam()))
        RespawnVIPGlow(teammate);
});

OnGameEvent("player_death", DeleteVIPGlow);
OnGameEvent("player_disconnect", DeleteVIPGlow);