//=========================================================================
//Script by: LizardOfOz.
//=========================================================================

//!CompilePal::IncludeDirectory("models/vip")
//!CompilePal::IncludeDirectory("materials/models/vip")
//!CompilePal::IncludeDirectory("scripts/vscripts/vip")

{
    local str = NetProps.GetPropString(self, "m_iszVScripts");
    local pos = regexp("[\\\\\\/].+\\.nut").search(str);
    ::projectDir <- pos ? str.slice(0, pos.begin + 1) : "/";
}

::Include <- function(path, scope = null)
{
    IncludeScript(projectDir + path, scope)
}

::CACHE_CUSTOM_CHARACTERS <- false;

Include("__lizardlib/_lizardlib.nut");
Include("_charlib/_charlib.nut");

::isDebug <- !IsDedicatedServer() && false;

::VIP_SCRIPTS <- {
    "mobster": [projectDir + "vip_mobster/_mobster.nut"]
}

::API_DEF_VALUES <- {
    "vip_character": "mobster",

    "snap_to_pickup": "0"
    "is_attack_defend": "1"
    "civilian_model": "models/vip/player/julius/julius.mdl"
    "cane_pickup_model": "models/weapons/w_models/w_tommygun.mdl"

    "civilian_hat_model": "models/vip/player/julius/julius_hat.mdl"
    "civilian_arms_model": "models/vip/weapons/c_models/c_julius_arms.mdl"
    "civilian_scale": "1.0"

    "vip_model": "models/vip/player/mobster/tfc_civilian.mdl"
    "vip_arms_model": "models/weapons/c_models/c_spy_arms.mdl"
    "vip_scale": "1.2"
    "cane_model": "models/vip/weapons/c_models/c_cane/c_cane.mdl"
    "snap_to_pickup": "0"
    "is_attack_defend": "1"
}

try { IncludeScript("vip_addons/manifest.nut"); } catch(e) { }
foreach (preloadAddonScript in preloadAddonScripts)
    try { IncludeScript.call(this, preloadAddonScript); } catch(e) { }

Include("gamemode/_gamemode.nut");

foreach (postloadAddonScript in postloadAddonScripts)
    try { IncludeScript.call(this, postloadAddonScript); } catch(e) { }