playerClass <- TF_CLASS_SNIPER;
model <- API_GetString("civilian_model");
viewmodelHands <- API_GetString("civilian_arms_model");
scale <- API_GetFloat("civilian_scale");

PrecacheModel(viewmodelHands);

Include("vip_shared/_vip_shared.nut");
Include("vip_civilian/civilian_weapons.nut");
IncludeScript("vip/vip_civilian/vip_buff_lockon.nut");
IncludeScript("vip/vip_civilian/vip_buffs.nut");
//Include("vip_civilian/vip_fixes.nut");

OnSelfGameEvent("post_inventory_application", 0, function()
{
    CreateViewModel(viewmodelHands);
    //CreateViewModel(API_GetString("cane_pickup_model"));

    self.AddHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    //vipBoostTokens <- vipBoostTokensStart;
    self.KeyValueFromString("targetname", "vip");

    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("dmg taken from fire reduced", 0.8, -1);
    self.AddCustomAttribute("dmg taken from crit reduced", 0.8, -1);
    self.AddCustomAttribute("damage bonus HIDDEN", 0.54, -1);
    self.AddCustomAttribute("fire rate bonus HIDDEN", 0.625, -1);

    self.SetHealth(175);
    self.SetMaxHealth(175);
    self.RemoveCond(TF_COND_DISGUISED);
    self.RemoveCond(TF_COND_DISGUISING);

    self.Weapon_Switch(EquipWeapon(GetWeaponTypeByName("cane")));

    foreach (otherPlayer in GetAlivePlayers())
    {
        if (otherPlayer.GetPlayerClass() != TF_CLASS_MEDIC)
            return;
        local medigun = otherPlayer.GetActiveWeapon();
        if (GetPropEntity(medigun, "m_hHealingTarget") == self)
            SetPropEntity(medigun, "m_hHealingTarget", null);
    }

    EntFireByHandle(SpawnEntityFromTable("info_teleport_destination",
    {
        origin = self.GetCenter(),
        vscripts = "vip/entities/vip_dispenser.nut",
        thinkfunction = "DispenserThink",
        TeamNum = self.GetTeam()
    }), "SetParent", "!activator", 0, self, self);

    AddTimer(1, function()
    {
        local hp = self.GetHealth();
        local newHP = clampCeiling(self.GetMaxHealth(), hp + 3);
        if (hp > 0 && newHP > hp)
            self.SetHealth(newHP);
    });
});

OnSelfGameEvent("clear_custom_character", 0, function(player, params)
{
    //KillLockVFX();
    self.RemoveHudHideFlags(HIDEHUD_PIPES_AND_CHARGE);
});

OnSelfEvent("player_death_next", function(params)
{
    SetPropBool(GetPropEntity(self, "m_hRagdoll"), "m_bGib", true);
});

OnSelfEvent("player_death_post", function(params)
{
    SetPropBool(GetPropEntity(self, "m_hRagdoll"), "m_bGib", true);
});