//If (sightline) to (current target)
    //If looking at (current target) within (small radius) - return aka keep (current target)
    //If looking at (current target) within (big radius) then...
        //If looking at (new target) within (small radius) - start counter on that player until target change
        //Else return aka keep (current target)
//Else - paint circle red and deny boosts
    //If looking at (new target) within (small radius) - start counter until target change

//On full counter: change target, start ALMOST FULL counter on the old target in //case you want to flick back

potentialTargetPoints <- player_collection(0);
currentLock <- null;
lastTickLock <- null;
lockOnVFXEntity <- null;
lockWasInSight <- false;

PrecacheModel("models/vip/status_effects/lockon_minicrits.mdl")
PrecacheModel("models/vip/status_effects/lockoff_minicrits.mdl")
PrecacheModel("models/vip/status_effects/lockon_speed.mdl")
PrecacheModel("models/vip/status_effects/lockoff_speed.mdl")
PrecacheModel("models/vip/status_effects/lockon_resistance.mdl")
PrecacheModel("models/vip/status_effects/lockoff_resistance.mdl")

function GetLockState()
{
    local points = potentialTargetPoints[currentTrace.entindex()] += 0.022;
}

AddTimer(-1, 0, function()
{
    local myEyePos = self.EyePosition();
    local eyeVector = self.EyeAngles().Forward();

    for (local i = 1; i <= MAX_PLAYERS; i++)
        potentialTargetPoints[i] = clampFloor(0, potentialTargetPoints[i] - 0.007);

    if (currentLock && !currentLock.IsAlive())
        currentLock = null;

    if (currentLock == null)
    {
        currentLock = TraceTarget();
        return;
    }

    local lockPos = currentLock.GetCenter();

    if (TraceLine(myEyePos, lockPos, self) > 0.97)
    {
        if (!lockWasInSight)
        {
            KillLockVFX();
            lockWasInSight = true;
        }
        local dotChecks = DotChecks(eyeVector, myEyePos, lockPos);
        if (dotChecks[0])
            return;
        local currentTrace = TraceTarget();
        if (!currentTrace)
            return;
        local points = potentialTargetPoints[currentTrace.entindex()] += 0.022;
        if (!dotChecks[1] || points > 1)
        {
            potentialTargetPoints[currentLock.entindex()] = 0.95;
            potentialTargetPoints[currentTrace.entindex()] = 0;
            currentLock = currentTrace;
        }

    }
    else
    {
        if (lockWasInSight)
        {
            KillLockVFX();
            lockWasInSight = false;
        }
        local currentTrace = TraceTarget();
        if (!currentTrace)
            return;
        local dotChecks = DotChecks(eyeVector, myEyePos, currentTrace.GetCenter());
        if (!dotChecks[0])
            return;
        local points = potentialTargetPoints[currentTrace.entindex()] += 0.022;
        if (!dotChecks[1] || points > 1)
        {
            potentialTargetPoints[currentLock.entindex()] = 0.95;
            potentialTargetPoints[currentTrace.entindex()] = 0;
            currentLock = currentTrace;
        }
    }
});

AddTimer(-1, 1, function()
{
    if (!currentLock || currentLock != lastTickLock)
        KillLockVFX();
    if (currentLock && !lockOnVFXEntity)
    {
        lockOnVFXEntity = Entities.CreateByClassname("obj_teleporter");
        lockOnVFXEntity.SetAbsOrigin(currentLock.GetCenter());
        lockOnVFXEntity.DispatchSpawn();
        lockOnVFXEntity.SetModel(
            format(
            "models/vip/status_effects/%s_%s.mdl",
            lockWasInSight ? "lockon" : "lockoff",
            selectedBuffType == 0 ? "minicrits" : selectedBuffType == 1 ? "resistance" : "speed"));
        lockOnVFXEntity.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION);
        lockOnVFXEntity.SetSolid(Constants.ESolidType.SOLID_NONE);
        SetPropBool(lockOnVFXEntity, "m_bPlacing", true);
        SetPropInt(lockOnVFXEntity, "m_fObjectFlags", 2);
        SetPropEntity(lockOnVFXEntity, "m_hBuilder", self);
        EntFireByHandle(lockOnVFXEntity, "SetParent", "!activator", 0, currentLock, currentLock);
    }

    lastTickLock = currentLock;
});

function DotChecks(eyeVector, eyePos, targetPos)
{
    local unitVectorToTarget = targetPos - eyePos;
    local distance = unitVectorToTarget.Norm();
    local dot = eyeVector.Dot(unitVectorToTarget);

    local radius = 3.4 * sqrt(distance);
    local dotC = (1 - dot) * pow(clampFloor(100, distance - 800), 0.65);
    debug_dot = dot;
    debug_mdot = (1 - dot);
    debug_dotC = dotC;
    debug_radius = radius;
    debug_distance = distance;

    local dotC2 = (1 - dot) * pow(distance, 0.2);
    debug_dotC2 = dotC2;

    //printl("dot="+dot)
    //printl("dotC="+dotC)

    //local radius = clampFloor(64, 64 / (distance + 1));
    //local radius = 5.4 * sqrt(distance);
    //DebugDrawCircle(targetPos, Vector(255, 255, 255), 15, radius, true, -1);

    //local radius2 = 50 * pow(distance, 0.38);
    //local radius2 = pow(distance + 400, 1.11) / 7;
    //DebugDrawCircle(targetPos, Vector(180, 180, 255), 15, radius2, true, -1);

    //return [dotC <= 0.425, dotC2 <= 0.42];
    return [dotC <= 0.625, dotC2 <= 0.42];
}

function TraceTarget()
{
    local forward = self.EyeAngles().Forward();
    local eyePos = self.EyePosition();

    local trace = {
        start = eyePos,
        end = eyePos + forward * 5500,
        mask = Constants.FContents.CONTENTS_HITBOX|Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
        ignore = self
    };
    TraceLineEx(trace);

    local target = safeget(trace, "enthit", null);
    if (IsValidPlayer(target) && IsTeammateOrSpy(self, target))
        return target;

    local trace = {
        start = eyePos,
        end = eyePos + forward * 5500,
        mask = Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
        ignore = self
    };
    TraceLineEx(trace);
    target = safeget(trace, "enthit", null);
    if (IsValidPlayer(target) && IsTeammateOrSpy(self, target))
        return target;
    return null;
}

function KillLockVFX()
{
    if (lockOnVFXEntity)
    {
        if (lockOnVFXEntity.IsValid())
            lockOnVFXEntity.Kill();
        lockOnVFXEntity = null;
    }
}
