vipBoostTokensStart <- 3;
vipBoostTokensMax <- 3;
vipBoostTokens <- 3;
pressedAttack2 <- false;
pressedReload <- false;
selectedBuffType <- 0;
lastTimeUsedOn <- 0;
lastPlayerUsedOn <- 0;
tokenRecharge <- 0;
buffDuration <- 8;
myTeam <- 0;
game_text_vip_boost <- null;

PrecacheScriptSound("Player.DenyWeaponSelection")
PrecacheScriptSound("WeaponMedigun_Vaccinator.Toggle")
PrecacheScriptSound("Player.HitSoundRetro")
PrecacheScriptSound("Player.DenyWeaponSelection")

PrecacheSound("vip/coin_boost_received.mp3")
PrecacheSound("vip/coin_regen.mp3")
PrecacheSound("vip/coin_throw_minicrits.mp3")
PrecacheSound("vip/coin_throw_resistance.mp3")
PrecacheSound("vip/coin_throw_speed.mp3")

OnSelfEvent("init_custom_character", 0, function()
{
    myTeam = self.GetTeam();

    game_text_vip_boost = SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 5,
        holdtime = 5,
        message = "",
        x = -1,
        y = 0.6
    });
});

AddTimer(0.15, 0, function()
{
    if (vipBoostTokens >= vipBoostTokensMax)
    {
        tokenRecharge = 0;
        return;
    }
    tokenRecharge += 2;
    if (tokenRecharge >= 100)
    {
        vipBoostTokens++;
        tokenRecharge = 0;
        EmitSoundEx({
            sound_name = "vip/coin_regen.mp3",
            filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_SINGLE_PLAYER,
            entity = self,
            speaker_entity = self
        });
    }
});

AddTimer(-1, 0, function()
{
    if (RandomInt(1, 5) == 1)
    {
        local playersOnCountCounter = safeget(extraData, "playersOnCountCounter", 0)
        local selectedBuffTypeStr = selectedBuffType == 0 ? "Mini-Crits" : selectedBuffType == 2 ? "Speed Boost" : "Damage Res."
        EntFireByHandle(game_text_vip_boost "AddOutput",
        "message Selected buff∶ " + selectedBuffTypeStr
            +"\nBuff Tokens∶ " + vipBoostTokens+BigToSmallNumbers(tokenRecharge)
            +"\n\n\n\n\nReload to switch buff. Right click to apply buff."
            +"\nPlayers near Point∶ "+playersOnCountCounter, 0, self, self);
        EntFireByHandle(game_text_vip_boost "Display", "", 0, self, self);
    }

    local buttons = GetPropInt(self, "m_nButtons");

    if (self.IsUsingActionSlot()
        || (buttons & IN_ATTACK3)
        || (buttons & IN_RELOAD))
    {
        if (pressedReload)
            return;
        pressedReload = true;
        selectedBuffType++;
        EmitSoundOnClient("WeaponMedigun_Vaccinator.Toggle", self);
        KillLockVFX();
        lastTimeUsedOn = 0;
        if (selectedBuffType > 2)
            selectedBuffType = 0;
    }
    else if (pressedReload)
        pressedReload = false;

    if (IsRoundSetup())
    {
        local setupTimeLeft = GetPropFloat(team_round_timer, "m_flTimerEndTime") - Time();
        if (setupTimeLeft < 10 && setupTimeLeft > 5)
            return;
    }

    if (buttons & IN_ATTACK2)
    {
        if (pressedAttack2)
            return;
        else
        {
            pressedAttack2 = true;

            if (vipBoostTokens <= 0 || !currentLock || (Time() - lastTimeUsedOn < buffDuration && lastPlayerUsedOn == currentLock))
            {
                EmitSoundOnClient("Player.DenyWeaponSelection", self);
                return;
            }

            local myEyePos = self.EyePosition();
            local lockCenter = currentLock.GetCenter();
            if (!DotChecks(self.EyeAngles().Forward(), myEyePos, lockCenter)[1] || TraceLine(myEyePos, lockCenter, self) < 0.97)
            {
                EmitSoundOnClient("Player.DenyWeaponSelection", self);
                return;
            }

            if (selectedBuffType == 0)
                AttachBuff(currentLock, TF_COND_OFFENSEBUFF, buffDuration);
            else if (selectedBuffType == 2)
                AttachBuff(currentLock, TF_COND_SPEED_BOOST, buffDuration);
            else
                AttachBuff(currentLock, TF_COND_DEFENSEBUFF, buffDuration);
            if (!IsRoundSetup() || GetPropFloat(team_round_timer, "m_flTimerEndTime") - Time() <= 5)
                vipBoostTokens--;

            EmitSoundEx({
                sound_name =
                    selectedBuffType == 0 ? "vip/coin_throw_minicrits.mp3"
                    : selectedBuffType == 1 ? "vip/coin_throw_resistance.mp3" :
                        "vip/coin_throw_speed.mp3"
                filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_SINGLE_PLAYER
                entity = self
            });
            EmitSoundEx({
                sound_name = "vip/coin_boost_received.mp3"
                filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_SINGLE_PLAYER
                entity = currentLock
            });
            lastTimeUsedOn = Time();
            lastPlayerUsedOn = currentLock;
        }
    }
    else if (pressedAttack2)
        pressedAttack2 = false;
});

function AttachBuff(player, condition, duration)
{
    local buffEnt = SpawnEntityFromTable("point_template", {
        teamnum = self.GetTeam()
    });
    EntFireByHandle(buffEnt, "Kill", "", duration, self, self);
    AddTimer(0.1, 0, function()
    {
        if (IsValidPlayer(player))
        {
            if ((player.InCond(TF_COND_STEALTHED) || player.InCond(TF_COND_DISGUISED)) && player.GetTeam() == self.GetTeam())
                return;
            player.AddCondEx(condition, 0.2, self);
        }
        else
            self.Kill();
    }, buffEnt);
}

OnSelfGameEvent("vip_death", function(params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (!attacker || attacker == self)
        return;
    if (selectedBuffType == 0)
        AttachBuff(attacker, TF_COND_OFFENSEBUFF, buffDuration);
    else if (selectedBuffType == 2)
        AttachBuff(attacker, TF_COND_SPEED_BOOST, buffDuration);
    else
        AttachBuff(attacker, TF_COND_DEFENSEBUFF, buffDuration);
    EmitSoundEx({
        sound_name = "vip/coin_boost_received.mp3"
        filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_SINGLE_PLAYER
        entity = attacker
    });
})