if ("typewriter" in WEAPON_TYPES)
    return;

WEAPON_TYPES["typewriter"] <- {
    name = "typewriter",
    baseclass = "tf_weapon_handgun_scout_primary",
    baseid = 16,
    viewmodel = "models/weapons/v_models/v_tommygun.mdl",
    worldmodel = "models/weapons/w_models/w_tommygun.mdl",
    OnEquip = function(player, weaponTT, weaponEnt)
    {
        weaponEnt.AddAttribute("bullets per shot bonus", 0.75, -1);
        weaponEnt.AddAttribute("fire rate bonus", 0.27, -1);
        weaponEnt.AddAttribute("clip size bonus", 10, -1);
        weaponEnt.AddAttribute("damage bonus HIDDEN", 0.4, -1);
        weaponEnt.AddAttribute("dmg falloff decreased", 0.35, -1);
        weaponEnt.AddAttribute("hidden primary max ammo bonus", 0.6, -1);
        //weaponEnt.AddAttribute("reload time increased", 3.0, -1);
        weaponEnt.SetClip1(40);
    }
};

WEAPON_TYPES["money_bag"] <- {
    name = "money_bag",
    baseclass = "tf_weapon_cleaver",
    baseid = 46,
    viewmodel = "models/weapons/c_models/c_scout_arms.mdl",
    worldmodel = "models/vip/weapons/c_models/money_bag.mdl",
    OnEquip = function(player, weaponTT, weaponEnt)
    {
        weaponEnt.AddAttribute("override projectile type", 1, -1);
        RunWithDelay(0.1, function()
        {
            SetPropIntArray(player, "m_iAmmo", 1, 5);
        })
    },
    OnSwitch = function(player, slotWeaponTT, slotWeaponEnt, prevWeaponTT)
    {
        local cc = GetCustomCharacter(player);
        cc.extraData.bag <- cc.CreateViewModel("models/vip/weapons/c_models/money_bag.mdl");
    },
    OnSwitchOff = function(player, weaponTT, weaponEnt, nextWeaponTT)
    {
        local data = GetCustomCharacter(player).extraData;
        if ("bag" in data)
        {
            DestroyIfValid(data.bag);
            delete data.bag;
        }
    },
    OnFire = function(player, weaponTT, weaponEnt)
    {
        printl(projectDir + "/vip_mobster/money_fountain.entity.nut")
        local cc = GetCustomCharacter(player);
        cc.bagThrowTime = Time();
        KillIfValid(cc.lastMoneyBag);
        RunWithDelay(0.2, function() {
            local projectile = SpawnEntityFromTable("prop_physics_override", {
                model = "models/vip/weapons/c_models/money_bag.mdl"
                origin = player.EyePosition()
                spawnflags = "4",
                massscale = 5
            });
            cc.lastMoneyBag = projectile;
            projectile.SetPhysVelocity(player.EyeAngles().Forward() * 4400 + Vector(0, 0, 200));
            AddTimer(-1, function()
            {
                local trace = {
                    start = self.GetOrigin(),
                    end = self.GetOrigin() - Vector(0, 0, 20),
                    ignore = self
                };
                TraceLineEx(trace);
                if (!safeget(trace, "enthit", player).IsPlayer())
                {
                    local moneyFountain = SpawnEntityFromTable("prop_dynamic",
                    {
                        origin = self.GetOrigin(),
                        vscripts = projectDir + "/vip_mobster/money_fountain.entity.nut",
                        TeamNum = player.GetTeam()
                    });
                    moneyFountain.SetOwner(player);
                    cc.lastMoneyBag = moneyFountain;
                    self.Kill();
                }
            }, projectile)
        });
    }
};

WEAPON_TYPES["lead_pipe"] <- {
    name = "lead_pipe",
    baseclass = "tf_weapon_shovel",
    viewmodel = "models/weapons/v_models/v_lead_pipe.mdl",
    worldmodel = "models/weapons/v_models/v_lead_pipe.mdl",
    baseid = 196,
    OnEquip = function(player, weaponTT, weaponEnt)
    {
        //weaponEnt.AddAttribute("damage bonus HIDDEN", 0.54, -1);
        //weaponEnt.AddAttribute("fire rate bonus HIDDEN", 0.625, -1);
    }
}