{
    local trace = {
        start = self.GetCenter(),
        end = self.GetOrigin() - Vector(0, 0, 100),
        mask = Constants.FContents.CONTENTS_HITBOX|Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
        ignore = self
    };
    TraceLineEx(trace);
    local endpos = safeget(trace, "endpos", null);
    if (endpos)
        self.SetAbsOrigin(endpos);
}

startTime <- Time();
affectedPlayers <- {};

local DURATION = 5;
local LINGER_DURATION = 1;

self.SetModelSimple("models/passtime/duffel_bags/duffel_red_open.mdl");
PrecacheSound(")items/powerup_pickup_regeneration.wav")
PrecacheSound(")ambient/medieval_flag.wav")
EmitSoundEx({
    sound_name = ")items/powerup_pickup_regeneration.wav",
    entity = self,
    volume = 1,
    sound_level = 90
});
EmitSoundEx({
    sound_name = ")ambient/medieval_flag.wav",
    entity = self,
    volume = 1,
    sound_level = 90
});

for (local x = -175; x <= 200; x += 87)
    for (local y = -175; y <= 200; y += 87)
        EntFireByHandle(SpawnEntityFromTable("info_particle_system",
        {
            origin = self.GetOrigin() + Vector(x, y, 0),
            effect_name = "utaunt_cash_confetti",
            start_active = 1
        }), "SetParent", "!activator", -1, self, self);

RunWithDelay(DURATION, function()
{
    EmitSoundEx({
        sound_name = ")ambient/medieval_flag.wav",
        entity = self,
        flags = 4
        volume = 1,
        sound_level = 90
    });
    self.Kill();
});

AddTimer(0.2, function()
{
    if (Time() - startTime <= DURATION)
    {
        local myPos = self.GetOrigin();
        foreach (player in GetAlivePlayers(self.GetTeam()))
            if ((myPos - player.GetOrigin()).Length() < 325)
            {
                if (player in affectedPlayers)
                    affectedPlayers[player].expireTime <- Time() + LINGER_DURATION;
                else
                {
                    local moneyBuffEnt = SpawnEntityFromTable("info_teleport_destination",
                    {
                        origin = self.GetCenter(),
                        vscripts = projectDir + "/vip_mobster/money_buff.entity.nut",
                        TeamNum = self.GetTeam()
                    });
                    moneyBuffEnt.SetOwner(self.GetOwner());
                    moneyBuffEnt.ValidateScriptScope();
                    affectedPlayers[player] <- moneyBuffEnt.GetScriptScope();
                    EntFireByHandle(moneyBuffEnt, "SetParent", "!activator", -1, player, player);
                }
            }
    }
});