OnSelfEvent("init_custom_character", 0, function()
{
    local myTeam = self.GetTeam();

    local teamPointOrigins = [];
    for (local point; point = Entities.FindByClassname(point, "team_control_point");)
        if (myTeam != point.GetTeam())
            teamPointOrigins.push(point.GetOrigin());

    local lastNag = 0;
    local playersOnCountCounter = 0;

    AddTimer(3, 1, function()
    {
        local pointPos = null;
        foreach (pointOrigin in teamPointOrigins)
        {
            playersOnCountCounter = 0;
            foreach (player in GetAlivePlayers())
            {
                if (player != self && player.GetTeam() == myTeam && (player.GetOrigin() - pointOrigin).Length2D() < 400)
                    playersOnCountCounter++;
            }
            if (playersOnCountCounter >= 2)
                pointPos = pointOrigin;
        }
        extraData.playersOnCountCounter <- playersOnCountCounter;

        if (playersOnCountCounter >= 2 && Time() - lastNag > 10 && pointPos && self && (self.GetOrigin() - pointPos).Length2D() > 600)
        {
            lastNag = Time();
            SendGlobalGameEvent("show_annotation",
            {
                worldPosX = pointPos.x,
                worldPosY = pointPos.y,
                worldPosZ = pointPos.z,
                id = 123,
                text = "Capture to the Control Point!",
                lifetime = 10,
                visibilityBitfield = 1 << self.entindex(),
                play_sound = "ui/hint.wav"
            });
        }
    });
});